;----------------------------------------------------------------------------
;				NES Startup
;					Copyright (C) 2007, Tekepen
;----------------------------------------------------------------------------
.setcpu		"6502"
.autoimport	on
.IMPORTZP	sp

.global	_NesMain

; iNESwb_ ڍׂ https://wiki.nesdev.com/w/index.php/INES
; }bp[̎ނ̎ https://img.atwikiimg.com/www34.atwiki.jp/cc65/pub/suzume/mappers.txt
.segment "HEADER"
	.byte	$4E, $45, $53, $1A	; "NES" Header
	.byte	$02			; PRG-ROM̃oN(y[W) 1oN16KB
	.byte	$01			; CHR-ROM̃oN(y[W) 1oN 8KB
	.byte	$00			; Flag6 b0=0: Horizontal Mirror b0=1:Vetrical Mirror
	.byte	$00			; Flag7 Flag6Flag7̏4bit}bp[No. ̏Ԃ̓}bp[0(PRG-ROM:32KB CHR-ROM:8KBőTCŶ)
	.byte	$00, $00, $00, $00	; 
	.byte	$00, $00, $00, $00	; 

.segment "STARTUP"
; Zbg荞
.proc	Reset
	sei
	ldx	#$ff
	txs
	
	; \tgEFAX^bNݒ
	lda	#$ff
	sta	sp
	lda	#$03
	sta	sp + 1
	
	jsr	_NesMain

.endproc


.import	_g_sync
.import	_g_ppuctrl1_value
.import	_g_bgcmd_cnt
.import	_ksd_mainproc

; VBlank荞
.proc	NMI
	; WX^ޔ
	pha
	txa
	pha
	tya
	pha

	; ҂JnmF
	lda	_g_sync
	beq	NMI_EXIT
	
	; XvCgDMA]Jn
	lda	#$00
	sta	$2003				; OAMADDR($2003) = 0
	lda	#$07
	sta	$4014				; OAMDMA($4014)  = (SPWADDR($0700) >> 8)

	; BG]R}hs
	lda	_g_bgcmd_cnt
    cmp	#$80
	bcs	BG_CMD_EXIT			; (_g_bgcmd_cnt > BGWSIZE(0x80))  jmp BG_CMD_EXIT

	ldy	#0
	jmp	CHECK_CNT
SET_BGADDR:
	iny
	lda	$0680,y				; a = *(BGWADDR($0680)+y)	]AhXʓǂݍ
	sta	$2006				; PPUADDR($2006) = a		VRAMAhXɃZbg
	iny
	lda	$0680,y				; a = *(BGWADDR($0680)+y)	]AhXʓǂݍ
	sta	$2006				; PPUADDR($2006) = a		VRAMAhXɃZbg
SEND_BGDATA:
	iny
	lda	$0680,y				; a = *(BGWADDR($0680)+y)	]BGf[^ǂݍ
	sta	$2007				; PPUDATA($2007) = a		VRAMɏ
	dex
	bne	SEND_BGDATA			; xɓǂ񂾃R}hJE^0ȂȂBGf[^]s
	iny
CHECK_CNT:
	ldx	$0680,y				; x = *(BGWADDR($0680)+y)
	bne	SET_BGADDR			; R}hJE^0ȂȂBGR}h]

BG_CMD_EXIT:

	; BGXN[Zbg
	; (PPU䂳ƃXN[ʒuɕςdl炵j
	lda $2002				; 荞݋܂ɓǂłȂNMI
	lda	_g_ppuctrl1_value
	sta	$2000				; PPUCTRL1  = g_ppuctrl1_value
	lda	#0
	sta	$2005				; PPUSCROLL = 0 (SCROLLX=0)
	sta	$2005				; PPUSCROLL = 0 (SCROLLY=0)
	
	; ݒ
	sta	_g_sync				; g_sync = 0
	
NMI_EXIT:

; mNLɂƃTEhɂ鎞Ԃ
; ʕ\̂ǂ̂炢̈ʒu܂łĂ̂o
; ł܂B^Ȃނ(@num_kadoma)ɋĒ܂B
; 肪Ƃ܂(*LցM*)
;lda #%00011111 ; mN on
;sta $2001

	; TEhhCoCTu[`R[
	jsr	_ksd_mainproc

;lda #%00011110 ; mN off
;sta $2001

	; WX^A
	pla
	tay
	pla
	tax
	pla

	; 荞ݏI
	rti
.endproc

.segment "VECINFO"
	.word	NMI		; $FFFA:NMI荞 VBlank̎ɔ
	.word	Reset	; $FFFC:Zbg荞 NƃZbgɔ
	.word	$0000	; $FFFE:IRQ/BRK荞 HW荞(IRQ)SW荞(BRK)ɂĔ

; p^[e[u
.segment "CHARS"
	.incbin	"character.chr"
