//
// cmnlib.c
// ʏCu
//
// Copyright (c) 2021 ڂ(@voich2014 in Twitter)
//
// Released under the MIT license.
// see https://opensource.org/licenses/MIT
// Where a citation is listed, please also check the license of the citing source.
//

#include "cmnlib.h"

//---------------------------------------------------------------------------
// O[oϐ 
//---------------------------------------------------------------------------
unsigned char  g_ppuctrl1_value = 0;
unsigned char  g_sync           = 0;	//VSyncƂ̓p
unsigned char  g_bgcmd_cnt      = 0;	//BG]R}h
unsigned char  g_bgcmd_cntwork;			//BG]R}hs̃JE^[N
unsigned char* g_bgcmd_ptr;				//BG]R}hs̃|C^[N

//---------------------------------------------------------------------------
// Cu֐ 
//---------------------------------------------------------------------------
void init_all(void)
{

	// S
	
	//BGƃXvCg̐ݒ
	const unsigned char nmi_enable = 0;	// but7:VBlankNMIs(0:sȂ,1:s)
	const unsigned char sp_size    = 0;	// bit5:XvCgTCY(0:8x8 1:8x16)
	const unsigned char bg_addr    = 0;	// bit4:BGp        CHRe[ũAhXI(0:$0000 1:$1000)
	const unsigned char sp_addr    = 1;	// bit3:XvCgpCHRe[ũAhXI(0:$0000 1:$1000)
	
	g_ppuctrl1_value = 0x40 | (nmi_enable << 7)
							| (sp_size    << 5)
							| (bg_addr    << 4)
							| (sp_addr    << 3);
	PPUCTRL1 = g_ppuctrl1_value;
	PPUCTRL2 = 0x06;
	
	wait_vblank();			// VBlank(VSync)҂
	show_enable(0,0);		// BGƃXvCg\OFF
	clear_all_sp();			// SXvCg
	clear_bg();				// SBG
	set_bg_scroll(0,0);		// BGXN[ʒu
	
}
//---------------------------------------------------------------------------
void wait_vblank(void)
{

	// VBlank(VSync)҂

	while((PPUSTATUS & 0x80) == 0);
	
}
//---------------------------------------------------------------------------
void show_enable(unsigned char bg,unsigned char sp)
{
	
	// ʕ\ON/OFF
	//
	// bg bit3:BG\        (0:OFF 1:ON)
	// sp bit4:XvCg\(0:OFF 1:ON)
	// 
	unsigned char stat = 0x06;	//BGƃXvCg̃NbvON
	stat |= ((bg << 3) | (sp << 4));
	
	PPUCTRL2 = stat;
	
}
//---------------------------------------------------------------------------
void set_ppu_addr(unsigned short addr)
{
	
	// PPUAhXݒ
	//
	// ̃WX^2񏑂݂ŃZbg
	// PPUSTATUSǂނƁAʁEʂ̏ԂZbg
	//
	
	PPUADDR = (addr >> 8);		//AhX̏8bit
	PPUADDR = (addr & 0xFF);	//AhX̉8bit
	
}
//---------------------------------------------------------------------------
void clear_all_sp(void)
{
	
	// SXvCg
	
	unsigned char* wram_ptr = (unsigned char*)SPWADDR;
	int i;
	
	//XvCg̃[NRAM[NA
	for(i = 0;i < SPWSIZE;++i)
	{	wram_ptr[i] = 0;	}
	
	//XvCg̈ʒuʊOɂĂ
	for(i = 0;i < 64;++i)
	{
		wram_ptr[(i << 2) + 0] = OUTSIDE;	//YW
		wram_ptr[(i << 2) + 3] = OUTSIDE;	//XW
	}
	
}
//---------------------------------------------------------------------------
void clear_bg(void)
{
	
	// SBG
	//
	// 2ʕ̃l[e[uƑe[uNA
	//
	short i;
	
	set_ppu_addr(0x2000);
	for(i = 0;i < 0x800;++i)
	{
		PPUDATA = 0;
	}

}
//---------------------------------------------------------------------------
void set_bg_scroll(unsigned short x,unsigned short y)
{
	
	// BGXN[ݒ
	//
	// ̃WX^2񏑂݂ŃZbg
	// PPUSTATUSǂނƁAXEY̏ԂZbg
	//
	
	unsigned char dummy = PPUSTATUS;	//X,Y̏ԃZbg
	
	PPUCTRL1  = g_ppuctrl1_value;		//Ȃbit0-1鎞̂ŃZbg
	
	PPUSCROLL = (x & 0xFF);				//XXN[
	PPUSCROLL = (y & 0xFF);				//YXN[

}
//---------------------------------------------------------------------------
void set_sp_pettern(unsigned char sp_idx,unsigned char tile_idx)
{
	
	// XvCgɃp^[Zbg
	
	unsigned char* wram_ptr = (unsigned char*)SPWADDR;
	unsigned char  pos      = (sp_idx << 2);	//index * 4
	
	wram_ptr[pos + 1] = tile_idx;
	
}
//---------------------------------------------------------------------------
void set_sp_pos(unsigned char sp_idx,unsigned char x,unsigned char y)
{

	// XvCg̈ʒuZbg

	unsigned char* wram_ptr = (unsigned char*)SPWADDR;
	unsigned char  pos      = (sp_idx << 2);	//index * 4
	
	wram_ptr[pos + 0] = y;
	wram_ptr[pos + 3] = x;

}
//---------------------------------------------------------------------------
void set_sp_palette(unsigned char sp_idx,unsigned char pal_idx)
{
	
	//XvCgɃpbgZbg
	
	unsigned char* wram_ptr = (unsigned char*)SPWADDR;
	unsigned char  pos      = (sp_idx << 2) + 2;	//index * 4 + 2
	
	wram_ptr[pos] = (wram_ptr[pos] & 0xFC) | pal_idx;	//pal_idx0`3̑O

}
//---------------------------------------------------------------------------
void set_palette(unsigned char pal_kind,unsigned char pal_idx,const unsigned char* pal)
{
	
	//pbgݒ
	
	//pbg̎ނƃCfbNXPPŨAhXݒ
	PPUADDR = 0x3F;
	PPUADDR = pal_kind + (pal_idx << 2);
	
	//pbg|C^̐4oCgi[ĂOŏ
	PPUDATA = pal[0];
	PPUDATA = pal[1];
	PPUDATA = pal[2];
	PPUDATA = pal[3];

}
//---------------------------------------------------------------------------
void set_bg_pattern(unsigned short x,unsigned short y,unsigned char tile_idx)
{
	
	//BGɃp^[Zbg
	unsigned short offset = 0;
	unsigned short addr   = 0x2000;
	
	//YW30ȏ2ʖڂɂȂ
	if(30 <= y)
	{
		offset = 0x0400;
		y %= 30;
	}
	
	addr += (offset + (y << 5) + x);
	set_ppu_addr(addr);
	PPUDATA = tile_idx;
	
}
//---------------------------------------------------------------------------
void set_bg_palette(unsigned short x,unsigned short y,unsigned char pal_data)
{
	
	//BGɃpbgZbg
	unsigned short offset = 0;
	unsigned short addr   = 0x23C0;
	
	//YW30ȏ2ʖڂɂȂ
	if(30 <= y)
	{
		offset = 0x0400;
		y %= 30;
	}
	
	//
	// e[úA2x2L1O[vƂāAeO[v
	// Ƃ̃pbgCfbNX2bitŁA1oCg
	// 4O[ṽpbgݒ
	// 
	// 1oCg      +--+--+
	// bit:76543210   |00|11| 00 ` 33 12x2̃LN^
	// pos:33221100   +--+--+ ܂葮e[u1oCg16LN^
	//                |22|33|
	//                +--+--+
	// Ql
	// https://wiki.nesdev.com/w/index.php/PPU_attribute_tables
	//
	addr += (offset + ((y >> 2) << 3) + (x >> 2));
	set_ppu_addr(addr);
	PPUDATA = pal_data;

}
//---------------------------------------------------------------------------
void set_bg_string(unsigned short x,unsigned short y,unsigned char* pszstr)
{

	//BGɕZbg
	//
	// pszstr:[I[̕f[^ւ̃|C^
	//
	unsigned short offset = 0;
	unsigned short addr   = 0x2000;
	
	//YW30ȏ2ʖڂɂȂ
	if(30 <= y)
	{
		offset = 0x0400;
		y %= 30;
	}
	
	addr += (offset + (y << 5) + x);
	
	while(*pszstr != '\0')
	{
		// PPUAhXݒ
		//
		// ̃WX^2񏑂݂ŃZbg
		// PPUSTATUSǂނƁAʁEʂ̏ԂZbg
		//
		PPUADDR = (addr >> 8);		//AhX̏8bit
		PPUADDR = (addr & 0xFF);	//AhX̉8bit
		
		//BG^Cp^[Zbg
		PPUDATA = *pszstr;
		
		//
		addr++;
		pszstr++;
	}
	
}
//---------------------------------------------------------------------------
unsigned char get_controller1(void)
{
	
	//Rg[P
	unsigned char button = 0;
	unsigned char i;
	
	//͂̊Jnƃb`
	JOYPAD1 = 0x01;
	JOYPAD1 = 0x00;
	
	//8AœǂݍŊe{^̏Ԃ擾
	for(i = 0;i < 8;++i)
	{
		button <<= 1;
		if(JOYPAD1 & 0x01)
		{ button |= 0x01; }
	}
	
	return button;
	
}
//---------------------------------------------------------------------------


