//
// cmnlib.h
// ʏCu
//
// Copyright (c) 2021 ڂ(@voich2014 in Twitter)
//
// Released under the MIT license.
// see https://opensource.org/licenses/MIT
// Where a citation is listed, please also check the license of the citing source.
//

//---------------------------------------------------------------------------
// 萔E}N` 
//---------------------------------------------------------------------------
#define PPUCTRL1     (*(char*)0x2000)   	// PPU䃌WX^1
#define PPUCTRL2     (*(char*)0x2001)   	// PPU䃌WX^2
#define PPUSTATUS    (*(char*)0x2002)   	// PPUXe[^XWX^
#define OAMADDR      (*(char*)0x2003)   	// OAMAhX|[g
#define OAMDATA      (*(char*)0x2004)   	// OAMf[^|[g
#define PPUSCROLL    (*(char*)0x2005)   	// PPUXN[WX^
#define PPUADDR      (*(char*)0x2006)   	// PPUAhXWX^
#define PPUDATA      (*(char*)0x2007)   	// PPUf[^WX^
#define JOYPAD1      (*(char*)0x4016)   	// Rg[[1
#define JOYPAD2      (*(char*)0x4017)   	// Rg[[2
#define PULSE1CTR1   (*(char*)0x4000)   	// `g1䃌WX^1
#define PULSE1CTR2   (*(char*)0x4001)   	// `g1䃌WX^2
#define PULSE1FREQ1  (*(char*)0x4002)   	// `g1g1
#define PULSE1FREQ2  (*(char*)0x4003)   	// `g1g2
#define PULSE2CTR1   (*(char*)0x4004)   	// `g2䃌WX^1
#define PULSE2CTR2   (*(char*)0x4005)   	// `g2䃌WX^2
#define PULSE2FREQ1  (*(char*)0x4006)   	// `g2g1
#define PULSE2FREQ2  (*(char*)0x4007)   	// `g2g2
#define NOISECTRL    (*(char*)0x400C)   	// mCY䃌WX^
#define NOISERND     (*(char*)0x400E)   	// mCYWX^
#define NOISETIME    (*(char*)0x400F)   	// mCYԃWX^
#define OAMDMA       (*(char*)0x4014)   	// OAM(Object Attribute Memory) DMAWX^
#define SNDCHANNEL   (*(char*)0x4015)		// TEh`l
#define PULSE_HZ(hz) (((1790000/16)/hz)-1)	//`g̎gݒlvZ}N
#define TRI_HZ(hz)   (1790000/((hz+1)*32))	//Opg̎gݒlvZ}N
#define BGWADDR      (0x0680)				// BG]R}h[N̊i[AhX
#define BGWSIZE      (0x80)					// BG]R}h[ÑTCY(0x80 = 128)
#define SPWADDR      (0x0700)   	        // XvCg[N̊i[AhX
#define SPWSIZE      (0x100)        	    // XvCg[ÑTCY(4 * 64 = 256)

#define BUTTON_A      (0x80)                // {^ A
#define BUTTON_B      (0x40)                // {^ B
#define BUTTON_SELECT (0x20)                // {^ SELECT
#define BUTTON_START  (0x10)                // {^ START
#define BUTTON_UP     (0x08)                // {^ ()
#define BUTTON_DOWN   (0x04)                // {^ ()
#define BUTTON_LEFT   (0x02)                // {^ ()
#define BUTTON_RIGHT  (0x01)                // {^ E()
#define BUTTON_UDLR   (0x0F)                // \L[rbg}XN

#define OUTSIDE       (240)                 // ʊO̍W
#define XPOS_OUT      (256)                 // X̊O
#define YPOS_OUT      (240)                 // Y̊O
#define BG_WIDTH      (32)                  // XBGL
#define BG_HEIGHT     (30)                  // YBGL
#define BG_NAME_ADDR1 (0x2000)              // BG̃l[e[u擪PPUAhX(1ʖ)
#define BG_ATTR_ADDR1 (0x23C0)              // BF̑e[u擪PPUAhX(1ʖ)

#define PAL_KIND_BG   (0x00)                // pbgBG
#define PAL_KIND_SP   (0x10)                // pbgʃXvCg


extern unsigned char  g_sync;				//VSyncp
extern unsigned char  g_ppuctrl1_value;		//BGXN[l[Zbgp
extern unsigned char  g_bgcmd_cnt;			//BG]R}h
extern unsigned char  g_bgcmd_cntwork;		//BG]R}hs̃JE^[N
extern unsigned char* g_bgcmd_ptr;			//BG]R}hs̃|C^[N

//---------------------------------------------------------------------------
// Cu֐錾 
//---------------------------------------------------------------------------

// S
void init_all(void);
	
// VBlank(VSync)҂
void wait_vblank(void);

// ʕ\ON/OFF
void show_enable(unsigned char bg,unsigned char sp);

// PPUAhXݒ
void set_ppu_addr(unsigned short addr);

// SXvCg
void clear_all_sp(void);

// SBG
void clear_bg(void);

// BGXN[ݒ
void set_bg_scroll(unsigned short x,unsigned short y);

// XvCgɃp^[Zbg
void set_sp_pettern(unsigned char sp_idx,unsigned char tile_idx);

// XvCg̈ʒuZbg
void set_sp_pos(unsigned char sp_idx,unsigned char x,unsigned char y);

// XvCgɃpbgZbg
void set_sp_palette(unsigned char sp_idx,unsigned char pal_idx);

//pbgݒ
void set_palette(unsigned char pal_kind,unsigned char pal_idx,const unsigned char* pal);

//BGɃp^[Zbg
void set_bg_pattern(unsigned short x,unsigned short y,unsigned char tile_idx);

//BGɃpbgZbg
void set_bg_palette(unsigned short x,unsigned short y,unsigned char pal_data);

//BGɕZbg
void set_bg_string(unsigned short x,unsigned short y,unsigned char* pszstr);

//Rg[P
unsigned char get_controller1(void);

//NMI荞݋
#define StartNMI()					\
{									\
	unsigned char dummy = PPUSTATUS;\
	g_ppuctrl1_value |= 0x80;		\
	PPUCTRL1 = g_ppuctrl1_value;	\
}

//NMI荞݋֎~
#define StopNMI()					\
{									\
	g_ppuctrl1_value &= 0x7F;		\
	PPUCTRL1 = g_ppuctrl1_value;	\
}

// ݏ҂
#define Sync() 					\
{								\
	g_sync = 1; 				\
	while((PPUSTATUS & 0x80));	\
	while(g_sync);				\
}

// ҂JnmF
#define CheckSync() (g_sync)

// ݒ
#define DoneSync() g_sync = 0;

// XvCgf[^DMA]Jn
#define start_sp_dma()			\
{								\
	OAMADDR = 0;				\
	OAMDMA  = (SPWADDR >> 8);	\
}

// BG]R}h[N̏
#define init_bg_cmd_work()					\
{											\
	unsigned char i = 0;					\
	do										\
	{										\
		((unsigned char*)BGWADDR)[i++] = 0;	\
	} while(i < BGWSIZE);					\
}

// BG]R}h
#define reset_bg_cmd()				\
{									\
	g_bgcmd_cnt = 0;				\
	*((unsigned char*)BGWADDR) = 0;	\
}

// BG]R}hf[^ǉ(l[e[u)
// (1ʖڂlȂ)
#define add_bg_name_cmd(x,y,data_ptr,cnt)							\
{ 																	\
	unsigned short addr = BG_NAME_ADDR1;							\
	unsigned short pos  = BGWADDR + g_bgcmd_cnt;					\
	unsigned char i;												\
	addr += (((y) << 5) + (x));										\
	*((unsigned char*)(pos    )) = cnt;								\
	*((unsigned char*)(pos + 1)) = (unsigned char)(addr >> 8);		\
	*((unsigned char*)(pos + 2)) = (unsigned char)addr;				\
	g_bgcmd_cnt += 3;												\
	for(i = 0;i < cnt;++i)											\
	{																\
		((unsigned char*)BGWADDR)[g_bgcmd_cnt++] = (data_ptr)[i];	\
	}																\
}

// BG]R}hf[^ǉ(e[u)
// (1ʖڂlȂ)
#define add_bg_attr_cmd(x,y,data_ptr,cnt)							\
{ 																	\
	unsigned short addr = BG_ATTR_ADDR1;							\
	unsigned short pos  = BGWADDR + g_bgcmd_cnt;					\
	unsigned char i;												\
	addr += (((y >> 2) << 3) + (x >> 2));							\
	*((unsigned char*)(pos    )) = cnt;								\
	*((unsigned char*)(pos + 1)) = (unsigned char)(addr >> 8);		\
	*((unsigned char*)(pos + 2)) = (unsigned char)addr;				\
	g_bgcmd_cnt += 3;												\
	for(i = 0;i < cnt;++i)											\
	{																\
		((unsigned char*)BGWADDR)[g_bgcmd_cnt++] = (data_ptr)[i];	\
	}																\
}

// BG]R}hI[f[^ǉ
#define add_bg_end_cmd() 						\
{												\
	((unsigned char*)BGWADDR)[g_bgcmd_cnt] = 0; \
}

